;------------------------------------------------;
; SET OF FUNCTIONS CONVERTING NUMBERS TO STRINGS ;
;------------------------------------------------;

; FUNCTION: CONVERTS THE EAX VALUE TO THE 8-BYTE HEXADECIMAL STRING
; IN:  EAX = 32-BIT VALUE, ES:DI = OUTPUT BUFFER
; OUT: NONE, ALL REGS ARE SAVED
HEX2STR PROC NEAR
        PUSH    DS
        PUSHAD
        MOV     DX, DATA16
        MOV     DS, DX
        LEA     SI, HEX_TAB
        MOV     CX, 8
H2S_1:
        ROL     EAX, 4
        MOVZX   BX, AL
        AND     BL, 0FH
        MOV     BL, DS:[SI+BX]
        MOV     ES:[DI], BL
        INC     DI
        LOOP    H2S_1
        POPAD
        POP     DS
        RET
HEX2STR ENDP

; FUNCTION: CONVERTS THE EAX VALUE TO THE 10-BYTE DECIMAL STRING
; IN:  EAX = 32-BIT VALUE, ES:DI = OUTPUT BUFFER
; OUT: NONE, ALL REGS ARE SAVED
DEC2STR PROC NEAR
        PUSHAD

        MOV     EBX, 10
        XOR     CX, CX

D2S_CYCLE:
        XOR     EDX, EDX
        DIV     EBX
        PUSH    DX
        INC     CX
        OR      EAX, EAX
        JNZ     D2S_CYCLE
        MOV     DX, 10
        SUB     DX, CX
D2S_CYC1:
        POP     AX
        ADD     AL, '0'
        MOV     ES:[DI], AL
        INC     DI
        LOOP    D2S_CYC1

        MOV     CX, DX
        JCXZ    D2S_DONE
        MOV     AL, 0
D2S_CYC2:
        MOV     ES:[DI], AL
        INC     DI
        LOOP    D2S_CYC2

D2S_DONE:
        POPAD
        RET
DEC2STR ENDP
